-- Implementation of quicksort with partition

perm []     = []
perm (x:xs) = ndinsert (perm xs)
    where ndinsert [] = [x]
          ndinsert (y:ys) = (x:y:ys) ? (y:ndinsert ys)

sorted [] = True
sorted [_] = True
sorted (x:y:ys) = x <= y && sorted (y:ys)

sort'pre _ = success
sort'post x y = y =:= perm x & sorted y =:= True

sort :: [Int] -> [Int]
sort [] = []
sort (x:xs) = let (low,high) = part x xs in sort low ++ x : sort high

part'pre _ _ = success
part'post x xs (u,v) = (u++v) =:= perm xs & (all (<x) u && all (>=x) v) =:= True

part :: Int -> [Int] -> ([Int],[Int])
part x [] = ([],[])
part x (y:ys) = if y<x then (y:u,v) else (u,y:v)
       where (u,v) = part x ys


input = [26,18,5,4,16,8,16,22,26,17,21,14,3,26,17]
--input = [26,18,5,4,16,8,16,22,26,17]
